gtkmm 3.24.10

Public Member Functions | Static Public Member Functions | Related Symbols | List of all members
Gdk::PixbufAnimation Class Reference

The gdk-pixbuf library provides a simple mechanism to load and represent animations. More...

`#include <gdkmm/pixbufanimation.h>`

Inheritance diagram for Gdk::PixbufAnimation:
[legend]

## Public Member Functions
| PixbufAnimation (PixbufAnimation && src) noexcept
PixbufAnimation & | operator= (PixbufAnimation && src) noexcept
| ~PixbufAnimation () noexcept override
GdkPixbufAnimation * | gobj ()
| Provides access to the underlying C GObject.
const GdkPixbufAnimation * | gobj () const
| Provides access to the underlying C GObject.
GdkPixbufAnimation * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
int | get_width () const
| Queries the width of the bounding box of a pixbuf animation.
int | get_height () const
| Queries the height of the bounding box of a pixbuf animation.
bool | is_static_image () const
| If you load a file with new_from_file() and it turns out to be a plain, unanimated image, then this function will return true.
Glib::RefPtr< Pixbuf > | get_static_image ()
| If an animation is really just a plain image (has only one frame), this function returns that image.
G_GNUC_BEGIN_IGNORE_DEPRECATIONS Glib::RefPtr< PixbufAnimationIter > | get_iter (const GTimeVal * start_time)
| Get an iterator for displaying an animation.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< PixbufAnimation > | create_from_file (const Glib::ustring & filename)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gdk::PixbufAnimation > | wrap (GdkPixbufAnimation * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Detailed Description

The gdk-pixbuf library provides a simple mechanism to load and represent animations.

An animation is conceptually a series of frames to be displayed over time. Each frame is the same size. The animation may not be represented as a series of frames internally; for example, it may be stored as a sprite and instructions for moving the sprite around a background. To display an animation you don't need to understand its representation, however; you just ask gdk-pixbuf what should be displayed at a given point in time.

## Constructor & Destructor Documentation

## ◆ PixbufAnimation()

Gdk::PixbufAnimation::PixbufAnimation | ( | PixbufAnimation && | src | ) |
| noexcept

## ◆ ~PixbufAnimation()

Gdk::PixbufAnimation::~PixbufAnimation | ( |  | ) |
| override noexcept

## Member Function Documentation

## ◆ create_from_file()

Glib::RefPtr< PixbufAnimation > Gdk::PixbufAnimation::create_from_file | ( | const Glib::ustring & | filename | ) |
| static

## ◆ get_height()

int Gdk::PixbufAnimation::get_height | ( |  | ) | const

Queries the height of the bounding box of a pixbuf animation.

Returns
  Height of the bounding box of the animation.

## ◆ get_iter()

G_GNUC_BEGIN_IGNORE_DEPRECATIONS Glib::RefPtr< PixbufAnimationIter > Gdk::PixbufAnimation::get_iter | ( | const GTimeVal * | start_time | ) |

Get an iterator for displaying an animation.

The iterator provides the frames that should be displayed at a given time. It should be freed after use with Glib::object_unref().

start_time would normally come from Glib::get_current_time(), and marks the beginning of animation playback. After creating an iterator, you should immediately display the pixbuf returned by Gdk::PixbufAnimationIter::get_pixbuf(). Then, you should install a timeout (with Glib::timeout_add()) or by some other mechanism ensure that you'll update the image after Gdk::PixbufAnimationIter::get_delay_time() milliseconds. Each time the image is updated, you should reinstall the timeout with the new, possibly-changed delay time.

As a shortcut, if start_time is nullptr, the result of Glib::get_current_time() will be used automatically.

To update the image (i.e. possibly change the result of Gdk::PixbufAnimationIter::get_pixbuf() to a new frame of the animation), call Gdk::PixbufAnimationIter::advance().

If you're using Gdk::PixbufLoader, in addition to updating the image after the delay time, you should also update it whenever you receive the area_updated signal and Gdk::PixbufAnimationIter::on_currently_loading_frame() returns true. In this case, the frame currently being fed into the loader has received new data, so needs to be refreshed. The delay time for a frame may also be modified after an area_updated signal, for example if the delay time for a frame is encoded in the data after the frame itself. So your timeout should be reinstalled after any area_updated signal.

A delay time of -1 is possible, indicating "infinite."

Parameters

  start_time | Time when the animation starts playing.

Returns
  An iterator to move over the animation.

## ◆ get_static_image()

Glib::RefPtr< Pixbuf > Gdk::PixbufAnimation::get_static_image | ( |  | ) |

If an animation is really just a plain image (has only one frame), this function returns that image.

If the animation is an animation, this function returns a reasonable thing to display as a static unanimated image, which might be the first frame, or something more sophisticated. If an animation hasn't loaded any frames yet, this function will return nullptr.

Returns
  Unanimated image representing the animation.

## ◆ get_type()

GType Gdk::PixbufAnimation::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_width()

int Gdk::PixbufAnimation::get_width | ( |  | ) | const

Queries the width of the bounding box of a pixbuf animation.

Returns
  Width of the bounding box of the animation.

## ◆ gobj() [1/2]

GdkPixbufAnimation * Gdk::PixbufAnimation::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GdkPixbufAnimation * Gdk::PixbufAnimation::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GdkPixbufAnimation * Gdk::PixbufAnimation::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ is_static_image()

bool Gdk::PixbufAnimation::is_static_image | ( |  | ) | const

If you load a file with new_from_file() and it turns out to be a plain, unanimated image, then this function will return true.

Use get_static_image() to retrieve the image.

Returns
  true if the "animation" was really just an image.

## ◆ operator=()

PixbufAnimation & Gdk::PixbufAnimation::operator= | ( | PixbufAnimation && | src | ) |
| noexcept

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gdk::PixbufAnimation > wrap | ( | GdkPixbufAnimation * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.